VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Generator"
   ClientHeight    =   3270
   ClientLeft      =   5865
   ClientTop       =   2805
   ClientWidth     =   2040
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3270
   ScaleWidth      =   2040
   Begin VB.TextBox txtWyniki 
      Height          =   2895
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   360
      Width           =   2055
   End
   Begin VB.TextBox txtNumer 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2055
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'tablica w ktorej beda przechowywane wszystkie mozliwe kombinacje (wyniki)
Private Wyniki() As String
'liczba, ktora przechowyje ile jest mozliwych kombinacji
Private iIloscElementow As Integer
Option Explicit

Private Sub txtNumer_KeyPress(KeyAscii As Integer)
Dim i As Byte 'licznik
Dim a As Byte 'bufor na wyciagany znak
Dim czas As Date

'jezeli nacisniety jest enter
If KeyAscii = vbKeyReturn Then
    'to ustaw przycisk na "nic" (nie bedzie dzwieku beep)
    KeyAscii = 0
    czas = Now
    'sprawdzanie czy podany wyraz jest liczba
    If IsNumeric(txtNumer.Text) = False Then  'jesli nie jest liczba to
        'inf. ze dany wyraz nie jest liczba
        MsgBox "Podany wyraz: " & txtNumer.Text & " nie jest liczb." & vbCrLf & vbCrLf _
                & "Wpisz poprawny numer.", vbInformation, "Bld przy wpisywaniu numeru"
        'zaznaczenie tekstu
        txtNumer.SelStart = 0
        txtNumer.SelLength = Len(txtNumer.Text)
        'wyjscie z procedury
        Exit Sub
    End If
    'sprawdzanie czy podany numer nie jest dluzszy niz 7 znakow
    If Len(txtNumer.Text) > 7 Then
        'jezeli dluzsza to msg i wyjscie z procedury
        MsgBox "Podany numer: " & txtNumer.Text & " jest duszy ni 7 znakw." & vbCrLf & vbCrLf _
                & "Wpisz poprawny numer.", vbInformation, "Bld przy wpisywaniu numeru"
        'zaznaczenie tekstu
        txtNumer.SelStart = 0
        txtNumer.SelLength = Len(txtNumer.Text)
        Exit Sub
        'wyjscie z procedury
    End If
    'sprawdzanie czy podana liczba jest calkowita
    If Not Int(txtNumer.Text) = txtNumer.Text Then
        'inf. ze dany wyraz nie jest liczba
        MsgBox "Podany wyraz: " & txtNumer.Text & " nie jest liczb cakowit." & vbCrLf & vbCrLf _
                & "Wpisz poprawny numer.", vbInformation, "Bld przy wpisywaniu numeru"
        'zaznaczenie tekstu
        txtNumer.SelStart = 0
        txtNumer.SelLength = Len(txtNumer.Text)
        'wyjscie z procedury
        Exit Sub
    End If
    'wyzerowanie wynikow
    txtWyniki.Text = ""
    'sprawdzanie ilosci mozliwych kombinacji
    iIloscElementow = IloscElementow
    'zmiana rozmiarow tablicy
    ReDim Wyniki(iIloscElementow)
    'wczytywanie pojedynczych cyfer
    For i = 1 To Len(txtNumer.Text)
        'wyciaganie kolejnej cyfry
        a = Mid(txtNumer.Text, i, 1)
        'wywolanie procedury
        Call ZmienCyfre(a)
    Next i
   ' MsgBox "Od: " & czas & " do: " & Now & " rnica: " & DateDiff("s", czas, Now) & " sekund.", vbInformation, "Czas trwania"
    Call WypiszWyniki
    End If
End Sub

Private Sub ZmienCyfre(Cyfra As Byte)
'zmienia cyfry na wybrane litery i podaje ilosc liter
Select Case Cyfra
    Case 0
        Call Wpisz("0", "0", "0", "", 3)
    Case 1
        Call Wpisz("1", "1", "1", "", 3)
    Case 2
        Call Wpisz("a", "b", "c", "", 3)
    Case 3
        Call Wpisz("d", "e", "f", "", 3)
    Case 4
        Call Wpisz("g", "h", "i", "", 3)
    Case 5
        Call Wpisz("j", "k", "l", "", 3)
    Case 6
        Call Wpisz("m", "n", "o", "", 3)
    Case 7
        Call Wpisz("p", "q", "r", "s", 4)
    Case 8
        Call Wpisz("t", "u", "v", "", 3)
    Case 9
        Call Wpisz("w", "x", "y", "z", 4)
    End Select
End Sub

Private Sub Wpisz(a1 As String, a2 As String, a3 As String, a4 As String, IloscLiter As Integer)
Dim i As Integer 'licznik
Dim j As Integer 'licznik
Dim a As String 'bufor na litery
Dim l As Integer
Dim x As Integer
Static k As Integer
Static z As Integer
If z = 0 Or z = 1 Then z = iIloscElementow: k = 0
z = (1 / IloscLiter) * z
k = k + 1
For i = 1 To IloscLiter
    Select Case i
        Case 1
            a = a1
        Case 2
            a = a2
        Case 3
            a = a3
        Case 4
            a = a4
    End Select
    If z <> 1 Then
        x = ((((i - 1) / Potega(IloscLiter, k)) * iIloscElementow) + 1)
    Else
        x = z + i - 1
    End If
    For j = x To iIloscElementow Step (IloscLiter * z)
        For l = j To (j + z - 1)
            Wyniki(l) = Wyniki(l) + a
        Next l
    Next j
Next i
End Sub

Private Sub WypiszWyniki()
Dim i As Integer 'licznik
Dim a As String
'wypisuje wyniki
For i = 1 To iIloscElementow
    a = a & Wyniki(i) & vbCrLf
Next i
txtWyniki = a
End Sub

Private Function IloscElementow() As Integer
Dim i As Byte
Dim a As Byte
Dim j As Integer
j = 1
For i = 1 To Len(txtNumer.Text)
    a = Mid(txtNumer.Text, i, 1)
    If a = 7 Or a = 9 Then
        j = j * 4
    Else
        j = j * 3
    End If
Next i
IloscElementow = j
End Function

Private Function Potega(Liczba As Integer, Stopien As Integer) As Integer
Dim i As Byte
Dim z As Integer
z = Liczba
For i = 1 To (Stopien - 1)
    z = z * Liczba
Next i
Potega = z
End Function

